import unittest
import sys
for path in ['../', './']:
    sys.path.insert(1, path)



class TestCoverage(unittest.TestCase):
    def test_init_main(self):
        # add modules folder to interpreter path
        import sys
        import os
        import prance
        from pathlib import Path
        modules_path = '../../../modules/'
        if os.path.exists(modules_path):
            sys.path.insert(1, modules_path)

        # init logging to file
        import logging
        LOG_FORMAT = ('%(levelname) -5s %(asctime)s %(name)s:%(funcName) -35s %(lineno) -5d:  %(message)s')
        logging.basicConfig(level=logging.INFO, format=LOG_FORMAT)
        LOGGER = logging.getLogger(__name__)

        #################################
        import connexion
        from security import swagger_util
        from env_info import is_running_locally, get_resources_path
        from messaging.ReconnectingMessageManager import ReconnectingMessageManager
        from messaging.MessageHandler import MessageHandler
        from flask import request
        from flask import redirect

        # init message handler
        from db.repository import Repository

        import main

    def test_routes(self):
        from routes import debug
        from routes import layers
        from routes import nodes

    def test_messaging(self):
        import network_constants as netconst
        from security.token_manager import TokenManager
        from db.entities import Layer

        import json
        import requests
        from typing import Dict, List
        from threading import Thread

        import logging
        from messaging import MessageHandler

    def test_db(self):
        import network_constants as netconst
        from database.MongoRepositoryBase import MongoRepositoryBase
        from db.entities import Layer

        import pymongo
        import json
        from typing import List, Dict

        # init logging to file
        import logging

        from db import repository
        from db.entities import layer


if __name__ == '__main__':
    unittest.main()
