import unittest
import sys
for path in ['../', './']:
    sys.path.insert(1, path)

class TestCoverage(unittest.TestCase):
    def test_init_main(self):
        print("Entered test main")
        # python -m unittest discover
        # add modules folder to interpreter path
        import sys
        import os
        import prance
        from pathlib import Path
        from typing import Dict, Any

        modules_path = '../../modules/'
        if os.path.exists(modules_path):
            sys.path.insert(1, modules_path)

        # init logging to file
        import logging
        LOG_FORMAT = ('%(levelname) -5s %(asctime)s %(name)s:%(funcName) -35s %(lineno) -5d:  %(message)s')
        logging.basicConfig(level=logging.INFO, format=LOG_FORMAT)
        LOGGER = logging.getLogger(__name__)

        #################################

        import connexion
        from security import swagger_util
        from env_info import is_running_locally, get_resources_path
        from flask import request
        from flask import redirect        

        import main #something in main is causing an infinite loop (probably an async task/ listener)
        print("Finished test main")

    def test_database(self):
        print("Entered test db")
        import network_constants as netconst
        from database.MongoRepositoryBase import MongoRepositoryBase

        import pymongo
        import json
        from db.entities.user import User
        from typing import List
        from db import repository

        print("Finished test db")

    def test_services(self):
        print("Entered test services")
        from functools import wraps
        from flask import g, request, redirect, url_for

        # global imports (dont't worry, red is normal)
        from db.repository import Repository
        from db.entities.user import User
        from services.user_service import UserService
        from env_info import get_resources_path

        import jwt
        from datetime import datetime, timedelta
        from typing import Dict
        import bcrypt

        from services import login_wrapper
        from services import token_service
        from services import user_service
        print("Finished test services")

    def test_routes(self):
        print("Entered test routes")
        from flask import request, Response
        from messaging.ReconnectingMessageManager import ReconnectingMessageManager 
        import json
        from flask import request
        # global imports (dont't worry, red is normal)
        from db.entities.user import User
        from services.user_service import UserService
        from services.login_wrapper import login_required
        from services.token_service import TokenService
        import bcrypt
        import jwt



        from routes import user
        #from routes import blockchain_trace  #message_sender in blockchain_trace is causing an infinite loop (probabily an async task//listener)
        from routes import debug
        print("Finished test routes")

    def test_add_users(self):
        print("Entered test users")
        # add modules folder to interpreter path
        import sys
        import os
        import json
        import prance
        from pathlib import Path
        from typing import Dict, Any

        modules_path = '../../modules/'
        if os.path.exists(modules_path):
            sys.path.insert(1, modules_path)

        from services.user_service import UserService
        from env_info import is_running_locally, get_resources_path
        import add_users
        print("Finished test users")



if __name__ == '__main__':
    unittest.main()
